<?php
/**
 * Created by JetBrains PhpStorm.
 * User: geovanesantos
 * Date: 20/05/14
 * Time: 14:47
 * To change this template use File | Settings | File Templates.
 */

namespace Scheduler\Logic;
require_once 'consumer.php';
set_time_limit(0);


//ConsumerStandBy::consume();
interface ConsumerStandByInterface{
    public static function runService();
    public static function consume();
    public static function restartConsumer();
    public static function handleError($id, $message);
}

abstract class ConsumerStandBy implements ConsumerStandByInterface
{
    public static $memoryReserve=null;
    public static function consume(){

        //register_shutdown_function(Array('\Scheduler\Logic\ConsumerStandBy','checkForFatalError'));

        try{

            \Scheduler\Logic\Consumer::executeProcessesInQueue(5);
        }
        catch(\Scheduler\Logic\ConsumerException $e){
            static::handleError($e->getJobId(), $e->getMessage());
        }
        catch(\Exception $e){
            \Scheduler\Logic\MailSender::sendErrorEmail("Erro: " . $e->getMessage());
        }

    }

    public static function checkForFatalError()
    {
        if (@is_array($e = @error_get_last()) && ($e['type'] === E_ERROR || $e['type'] === E_USER_ERROR)) {
            static::$memoryReserve=null;
            try{
                $file = isset($e['file']) ? $e['file'] : '';
                $line = isset($e['line']) ? $e['line'] : '';
                $msg = "Fatal - " . (isset($e['message']) ? $e['message'] : '');
                $msg .= " at {$file}({$line}).";
                $id=\Scheduler\Logic\Consumer::getCurrentProcess();
                static::handleError($id, $msg);
                //exec('service consumerStandBy restart');
                //exit();
                static::restartConsumer();

            }
            catch(\Exception $e){
                \Scheduler\Logic\MailSender::sendErrorEmail("Erro: " . $e->getMessage());
            }
        }
    }

    public static function handleError($id, $msg){
        \Scheduler\Logic\MailSender::sendErrorEmail($msg);
        \Scheduler\Logic\Consumer::setError($id);
    }

    //public abstract function restartConsumer();

    //public abstract function consumeLoop();
}
//ConsumerStandBy::consume();

class WindowsConsumerStandBy extends ConsumerStandBy{
    public static function runService(){

    }

    public static function restartConsumer(){

    }
}

class LinuxConsumerStandBy extends ConsumerStandBy{

    public static function runService(){
        static::$memoryReserve=str_repeat('@', 1024*1024);
        register_shutdown_function(Array('\Scheduler\Logic\LinuxConsumerStandBy','checkForFatalError'));
        //register_shutdown_function('self::checkForFatalError');

        while(true){
            static::consume();
        }
    }

    public static function restartConsumer(){
        exec('service consumerStandBy restart');
        exit();
    }
}

LinuxConsumerStandBy::runService();