function Dfs61000_Consultalote_Controller(ScreenService, templateManager, restEngine, ZHPromise) {

    var self = this;

    this.setarFiltro = function() {
        var widget = templateManager.container.getWidget("wdgListaLoteRps");
        widget.activate();
        var filterRow = templateManager.containers["df_saida#dfs61000_transmissao_nfse"].widgets[0].appliedFilter.FILTER_ROW;
        widget.dataSourceFilter[0].value = filterRow.CDEMPRESA;
        widget.dataSourceFilter[1].value = filterRow.CDINSCESTA;
        widget.dataSourceFilter[2].value = filterRow.CDINSCMUNI;
        widget.dataSource.data = null;
    };

    this.consultarLotes = function(rows, transmissao, widget, notas) {
        if(rows) {
            var valida = true;
            var lotesErro = null;
            rows.forEach(function(linha) {
                if (linha.IDSTATUSLOTERPS == 4) {
                    valida = false;
                    return;
                }
            });
    
            if (valida == false) {
                ScreenService.showMessage("Um ou mais lotes marcados já foram processados.");
            }
            else {
                var options = {
                    "requestType": "DataSet",
                    "dataset": rows
                };
    
                restEngine.post("df_saida#/consultarLotes", options,
                    function (success) {
                        if(success.dataset)
                            if(success.dataset.lotesErro) lotesErro = success.dataset.lotesErro;
                        if (success.messages != undefined) {
                            ScreenService.showMessage(success.messages[0].message);
                            if (!transmissao) widget.reload();
                            if (success.dataset && success.dataset.lotesAceitos[0]) {
                                var lotes = success.dataset.lotesAceitos;
                                lotes[0].notaserro = [];
                                self.aprovarLotesAceitos(success.dataset.lotesAceitos, success.messages[0].message).then(function(erro){
                                    if(erro && !erro.erro) {
                                        if(erro) {
                                            let nrNotasErros = erro.map((e) => e.NRNOTAFISC);
                                            lotes[0].notaserro = [...lotes[0].notaserro, ...nrNotasErros];
                                            self.gerarRelatorio(lotes, transmissao).then(function(success) {
                                                if(transmissao) ScreenService.restoreDefaultLoadingMessage();
                                                if(lotesErro)
                                                    this.openPopupErros([...erro, ...lotesErro]);
                                                widget.reload();
                                            }.bind(this));
                                            if(transmissao) ScreenService.restoreDefaultLoadingMessage();
                                        }
                                        this.openPopupErros(erro);
                                    }
                                    else if(success.dataset && success.dataset.lotesErro) {
                                        this.openPopupErros(success.dataset.lotesErro);
                                    }
                                    else {
                                        if(transmissao) ScreenService.restoreDefaultLoadingMessage();
                                        self.gerarRelatorio(success.dataset.lotesAceitos, transmissao).then(function(success){
                                            widget.reload();
                                        });
                                    }
                                }.bind(this));
                            }
                           else {
                                if(success.dataset) 
                                    if(success.dataset.lotesErro) this.openPopupErros(success.dataset.lotesErro);
                                if(transmissao) ScreenService.restoreDefaultLoadingMessage();
                                ScreenService.hideLoader();
                            }
                        }
                        else {
                            if(success.dataset) {
                                if(success.dataset.lotesErro) this.openPopupErros(success.dataset.lotesErro);
                            }
                            if(transmissao) {
                                ScreenService.restoreDefaultLoadingMessage();
                            }
                            ScreenService.hideLoader();
                        }
                        self.enviarEmailAutomatico(notas, widget); //tulio
                        
                    }.bind(this), undefined,
                    function (error) {
                        if(transmissao) {
                            ScreenService.restoreDefaultLoadingMessage();
                            widget.reload();
                        }
                        ScreenService.hideLoader();
                        ScreenService.showMessage("Ocorreu um erro inesperado.");
                        console.log(error);
                    }
                );
            }
        }
        else {
            if(transmissao) ScreenService.restoreDefaultLoadingMessage();
            if(!transmissao) ScreenService.showMessage('Nenhum lote foi selecionado.');
        }
    };

    this.voltarParaTransmissao = function() {
        ScreenService.goBack();
       templateManager.containers["df_saida#dfs61000_transmissao_nfse"].getWidget("wdgTransmissaoNfse").reload();
    };

    this.gerarRelatorio = function(lotes, transmissao) {
        var promise = ZHPromise.defer();

        var params = {
            "requestType": "DataSet",
            "dataset": lotes
        };
        restEngine.post("df_saida#/enviarEspelhoNfse", params/*,
        null, null, null, null, 3000000*/).then(function(response) {
            promise.resolve();
        }).catch(function(error) {
            ScreenService.showMessage(error.data.error);
        });
        if(transmissao) ScreenService.hideLoader();
        return promise;
    };

    this.aprovarLotesAceitos = function(lotes, message) {
        var params = {
            "requestType": "DataSet",
            "dataset": lotes
        };
        return restEngine.post("df_saida#/aprovarLotesAceitos", params).then(function(response) {
            if(response.dataset) {
                if(response.dataset.naoAprovaAutomatico) {
                    return {erro: true};
                }
                //message = message + '<br/><br/>Não foi possível realizar a aprovação automática das notas:';
                else if(response.dataset.errosAprovacao) {
                    if(response.dataset.errosAprovacao[0]) return response.dataset.errosAprovacao;
                }
                else if(response.data) {
                    return {erro: true};
                }
            }
        }).catch(function(error) {
            ScreenService.showMessage(error.data.error);
        });
    };
    
    // Após a atualização do lote, envia o email automaticamente - tulio
    this.enviarEmailAutomatico= function(notas, widget) {
        var params = {
            "requestType": "DataSet",
            "dataset": notas
        };

        return restEngine.post("df_saida#/enviaEmailAutomaticoNota", params, 
                function(success) {
                    if (success.messages && !success.error) {
                        ScreenService.successNotification('E-mail enviado com sucesso.');
                        widget.unSelectAll();
                        widget.reload();
                        ScreenService.closePopup();
                    }
                    else  if(success.error) {
                        ScreenService.errorNotification("Ocorreu um erro ao realizar o envio do e-mail. Contate o administrador do sistema.");
                    }
                    else {
                        ScreenService.showMessage('Erro ao enviar o email ou consultar o lote');
                        widget.unSelectAll();
                    }
                }, undefined,
                function(error) {
                    if(typeof error.data.error[0] !== 'string') this.openPopupErros(error.data.error);
                    else ScreenService.showMessage('Email não enviado');
                }.bind(this));
    };
    
    this.openPopupErros = function(erros) {
        if(erros[0]) {
            var widgetErros = templateManager.container.getWidget('WidgetErros');
            widgetErros.dataSource.data = erros;
            widgetErros.isVisible = true;
            ScreenService.openPopup(widgetErros);
            widgetErros.activate();
        }
    };
    
    this.closeErrosAprovacao = function(widget) {
        widget.isVisible = false;
        widget.dataSource.data = [];
        ScreenService.closePopup(widget);
        widget.getParent().activate();
        widget.getParent().unSelectAll();
        widget.getParent().reload();
    };

}

Configuration(function (ContextRegister) {
    ContextRegister.register("Dfs61000_Consultalote_Controller", Dfs61000_Consultalote_Controller);
});
