const { browser, element } = require('protractor');

function lancamentoVenda() {
	const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
	const z = new  ZeedhiAPIConstructor(browser, protractor);
	const Helper = require('teknisa-helper');
	const geral = new Helper.geral();
	const protractorHelper = require('protractor-helper');
	const self = this;
	
	this.abrir = () => {
	    z.component.menu.open();
	    protractorHelper.waitForElementVisibility(element(by.css('.menu-overlay')));
	    z.component.menu.clickByPath(['Documentos Fiscais', 'Saídas', 'Nota Fiscal Eletrônica', 'Transmissão de Nota Fiscal Eletrônica']);
	};

	this.openPopup = (fieldName) => {
		const elem = element.all(by.css(`#${fieldName} .zh-icon-search`)).last();
		protractorHelper.click(elem);
		z.util.isElementVisible(elem)
			.then((visible) => {
				if (visible) console.log(`Aberto o pop up do campo '${fieldName}'`);
				else console.error(`Não foi possível encontrar o campo '${fieldName}'`);
			});
	};

	this.searchTextOnFloating = (textField) => {
		const elem = $('.zh-floating-control .float-action.opened div.floating-card .floating-card-input .mousetrap');
		protractorHelper.fillFieldWithText(elem, textField);
		z.util.isElementVisible(elem)
			.then((visible) => {
				if (visible) console.log(`Texto '${textField}' buscado no filtro flutuante`);
			});
		// self.esperarLoading();
	};

	this.clickGrid = function (campo, valor, grid, Popup = false) {
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${grid}`)), 5000);
		z.widget.grid.click(campo, valor, grid, Popup);
	};

	this.searchAndClickGridField = (fieldId, textField, fieldNameGrid = fieldId, popUpGridId = '9000') => {
		// Abre o Popup do Campo
		self.openPopup(fieldId);
		// Escreve no campo de pesquisa
		self.searchTextOnFloating(textField);
		// clicka no texto  esperado
		self.clickGrid(fieldNameGrid, textField, popUpGridId, true);
	};

	this.clickLimparAutoComplete = (fieldId) => {
		const elem = element.all(by.css(`#${fieldId} .zh-icon-close-x`)).last();
		protractorHelper.click(elem, 5000);
		z.util.isElementVisible(elem)
			.then((visible) => {
				if (visible) console.log(`Valor do campo '${fieldId}' foi excluído, select auto-complete`);
			});
	};

	this.clickAndFillField = (id, texto) => {
		const elem = element.all(by.id(id)).last();
		z.util.isElementVisible(elem)
			.then((visible) => {
				if (visible) console.log(`Campo '${id}' preenchido com '${texto}'`);
				else console.error(`Não foi possível encontrar o campo '${id}'`);
			});
		protractorHelper.click(elem);
		protractorHelper.fillFieldWithText(elem, texto);
	};

	this.selectIntervalDate = function(fieldId, dateBegin, dateEnd, language) {
		
		protractorHelper.click(element.all(by.id(fieldId)).first());
        if(dateBegin){
            z.field.calendar.selectDate(dateBegin, language);
        }
        if(dateEnd){
            z.field.calendar.selectDate(dateEnd, language);
        }    
        z.component.footer.clickRightActionByLabel('OK', true);
    };
	
	this.filtroLancamentoVenda = (unidadeVenda, statusCancelada, statusUsoDenegado, destinatarioVenda) => {
		geral.selectNative('IDENTRSAIDOP', 'Saída');
		self.clickLimparAutoComplete('NMFILIAL');
		self.searchAndClickGridField('NMFILIAL', unidadeVenda);
		geral.limpaCampoPorId('IDSTATUSNFE');
		geral.selectMultiplo('IDSTATUSNFE', 'DSSTATUSNFE', statusCancelada);
		geral.selectMultiplo('IDSTATUSNFE', 'DSSTATUSNFE', statusUsoDenegado);
		geral.selectNative('IDORIGDESTNF', 'Cliente');
		self.searchAndClickGridField('NMRAZSOCCLIE', destinatarioVenda, 'NMRAZSOCCLIE');
	};
	
	this.digitarNotaFiscal = (operacaoVenda, modeloDocumentoVenda, destinatarioVenda, serieNFVenda) => {
		self.clickLimparAutoComplete('NMTIPOOPER');
		self.searchAndClickGridField('NMTIPOOPER', operacaoVenda);
		self.clickLimparAutoComplete('DSMODDOCFISC');
		self.searchAndClickGridField('DSMODDOCFISC', modeloDocumentoVenda);
		self.searchAndClickGridField('NMRAZSOCCLIE', destinatarioVenda);
		self.searchAndClickGridField('DSSERIE', serieNFVenda);
		z.field.calendar.clearFieldByXIcon('DTENTRSAID');
		self.clickAndFillField('DTENTRSAID', self.geraDataDoDia());
	};

	this.geraDataDoDia = function(){
		var today = new Date();
		var dd = today.getDate();
		var mm = today.getMonth()+1; //January is 0!
		var yyyy = today.getFullYear();

		if(dd<10) {
    		dd='0'+dd
		}

		if(mm<10) {
    		mm='0'+mm
		}

		today = dd+'/'+mm+'/'+yyyy;

		return today;
	};

	this.lancamentoProduto = (produtoVenda, quantidadeVenda, valorUnitVenda) => {
		element(by.id('NMPRODUTO')).click();
		self.searchAndClickGridField('NMPRODUTO', produtoVenda);
		geral.clickAndFillFields('QTITEMPROD', quantidadeVenda, 'VRUNITITEM', valorUnitVenda);
	};
};
module.exports = new lancamentoVenda();