const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geralPage = new Helper.geral();
const loginPage = new Helper.login();
const protractorHelper = require('protractor-helper');
const importacaArquivoXmlPage = require('../../../../page-objects/documentosfiscais/entrada/lancamentos/importacaArquivoXml.po.js');
const j = require('../../../../json/leitorJsonHela.po.js');
const importacaArquivoXmlGridId = '4037041933179304567641';

describe('Tela Importação de Arquivo XML', () => {
    beforeAll(() => {
        loginPage.login(j.getValor('login'), j.getValor('senha'), j.getValor('url'));
        importacaArquivoXmlPage.abrir();
        protractorHelper.waitForElementVisibility(element(by.id(`grid-${importacaArquivoXmlGridId}`)), 5000);
        browser.sleep(5000);
        importacaArquivoXmlPage.filtroInicial(j.getValor('nmfilialfilter'), j.getValor('cdinscestafilter'));
        geralPage.clickAplicarFiltro();
    });

    afterAll(() => {
        geralPage.sair();
    });

    it('Acessar tela Importação de Arquivo XML', () => {
        expect(z.component.header.getTitle()).toBe('Importação/Consulta de Notas Fiscais (Arquivo XML)');
    });

    it('Upload Xml', () => {
        importacaArquivoXmlPage.uploadXml();
        z.component.alert.clickMessageOk('OK');
        importacaArquivoXmlPage.refreshWidget();
        expect(geralPage.gridHasText('4037041933179304567641', j.getValor('nracessonfe'), 6)).toBe(j.getValor('nracessonfe'));
    });

    it('Editar Filial', () => {
        importacaArquivoXmlPage.editarFilial();
        expect(geralPage.gridHasText('4037041933179304567641', j.getValor('nmfilirece'), 1)).toBe(j.getValor('nmfiliece'));
    });
});